{*******************************************************************}
{    Register PColor 1.53                                           }
{    Draw 2D data - flat, interp, isoline.                          }
{    Copyright (c) 1999-2001 Andrey Filatkin                        }
{    All Rights Reserved                                            }
{    anfilat@chat.ru ;   http://www.chat.ru/~anfilat                }
{    Last modified - 16 October 2001                                }
{*******************************************************************}
unit PColorRg;

interface

uses Windows, Classes, Graphics, Controls, Forms, PColor, DsgnIntf,
     StdCtrls, ComCtrls, Dialogs, ExtCtrls, Sysutils;

type
  TPColorEditor = class(TForm)
    btnOK: TButton;
    btnCancel: TButton;
    PageControl1: TPageControl;
    tsImage: TTabSheet;
    tsTitle: TTabSheet;
    tsCoordinates: TTabSheet;
    cbTitleVisible: TCheckBox;
    edtTitle: TEdit;
    btnTitleFont: TButton;
    FontDialog1: TFontDialog;
    ColorDialog1: TColorDialog;
    cbDrawFacet: TCheckBox;
    cbMouseOn: TCheckBox;
    edtNumbCol: TEdit;
    Label4: TLabel;
    edtContourLines: TEdit;
    Label3: TLabel;
    cbCoordinatesAutomatic: TCheckBox;
    gbImage: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label20: TLabel;
    edtImageTop: TEdit;
    edtImageLeft: TEdit;
    edtImageHeight: TEdit;
    edtImageWidth: TEdit;
    gbColorBar: TGroupBox;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    edtColorBarTop: TEdit;
    edtColorBarLeft: TEdit;
    edtColorBarHeight: TEdit;
    edtColorBarWidth: TEdit;
    gbTitle: TGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    Label28: TLabel;
    edtTitleTop: TEdit;
    edtTitleLeft: TEdit;
    edtTitleWidth: TEdit;
    cobColorMap: TComboBox;
    cobTypeImage: TComboBox;
    cbMaxMinValGraphAuto: TCheckBox;
    pnlValGraph: TPanel;
    lblMaxValGraph: TLabel;
    edtMaxValGraph: TEdit;
    edtMinValGraph: TEdit;
    lblMinValGraph: TLabel;
    tsColorBar: TTabSheet;
    cbDrawColorBar: TCheckBox;
    rgColorBarKind: TRadioGroup;
    cobImageMode: TComboBox;
    cbGMaxMinValGraphAuto: TCheckBox;
    pnlGValGraph: TPanel;
    lblGMaxValGraph: TLabel;
    lblGMinValGraph: TLabel;
    edtGMaxValGraph: TEdit;
    edtGMinValGraph: TEdit;
    tsColors: TTabSheet;
    btnColorFon: TButton;
    btnColorImageFon: TButton;
    btnColorFacet: TButton;
    btnColorMax: TButton;
    btnColorMin: TButton;
    btnColorContour: TButton;
    btnLower: TButton;
    btnHigher: TButton;
    procedure cbTitleVisibleClick(Sender: TObject);
    procedure edtTitleChange(Sender: TObject);
    procedure btnTitleFontClick(Sender: TObject);
    procedure edtNumbColChange(Sender: TObject);
    procedure edtContourLinesChange(Sender: TObject);
    procedure cbDrawFacetClick(Sender: TObject);
    procedure cbMouseOnClick(Sender: TObject);
    procedure cbDrawColorBarClick(Sender: TObject);
    procedure rgColorBarKindClick(Sender: TObject);
    procedure btnColorFonClick(Sender: TObject);
    procedure btnColorImageFonClick(Sender: TObject);
    procedure btnColorFacetClick(Sender: TObject);
    procedure btnColorMaxClick(Sender: TObject);
    procedure btnColorMinClick(Sender: TObject);
    procedure cobColorMapChange(Sender: TObject);
    procedure cobTypeImageChange(Sender: TObject);
    procedure cbCoordinatesAutomaticClick(Sender: TObject);
    procedure edtImageTopChange(Sender: TObject);
    procedure edtImageLeftChange(Sender: TObject);
    procedure edtImageWidthChange(Sender: TObject);
    procedure edtImageHeightChange(Sender: TObject);
    procedure edtColorBarTopChange(Sender: TObject);
    procedure edtColorBarLeftChange(Sender: TObject);
    procedure edtColorBarWidthChange(Sender: TObject);
    procedure edtColorBarHeightChange(Sender: TObject);
    procedure edtTitleTopChange(Sender: TObject);
    procedure edtTitleLeftChange(Sender: TObject);
    procedure edtTitleWidthChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbMaxMinValGraphAutoClick(Sender: TObject);
    procedure edtMaxValGraphChange(Sender: TObject);
    procedure edtMinValGraphChange(Sender: TObject);
    procedure cbGMaxMinValGraphAutoClick(Sender: TObject);
    procedure edtGMaxValGraphChange(Sender: TObject);
    procedure edtGMinValGraphChange(Sender: TObject);
    procedure cobImageModeChange(Sender: TObject);
    procedure edtXKeyPress(Sender: TObject; var Key: Char);
    procedure btnColorContourClick(Sender: TObject);
    procedure btnLowerClick(Sender: TObject);
    procedure btnHigherClick(Sender: TObject);
  private
    FPColor : TPColor;
    PColorOld : TPColor;
    procedure SetPColor(Value: TPColor);
  public
    property PColor: TPColor read FPColor write SetPColor;
  end;

  TPColorComponentEditor = class (TComponentEditor)
  public
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure ExecuteVerb(Index: Integer); override;
    procedure Edit; override;
  end;

var
  NumbKeys : set of Char=['0'..'9','-',#8];

procedure Register;

implementation

{$R *.DFM}

procedure Register;
begin
  RegisterComponents('Samples', [TPcolor]);
  RegisterComponentEditor(TPcolor, TPColorComponentEditor);
end;

{ TPColorComponentEditor }

procedure TPColorComponentEditor.Edit;
var
  PColorEditor: TPColorEditor;
begin
  PColorEditor := TPColorEditor.Create(Application);
  try
    PColorEditor.PColor := TPColor(Component);
    if PColorEditor.ShowModal = mrOk then Designer.Modified;
  finally
    PColorEditor.Free;
  end;
end;

function TPColorComponentEditor.GetVerb(Index: Integer): string;
begin
  if Index = 0 then result := '&Edit PColor...'
  else result := '';
end;

function TPColorComponentEditor.GetVerbCount: Integer;
begin
  result := 1;
end;

procedure TPColorComponentEditor.ExecuteVerb(Index: Integer);
begin
  if Index = 0 then Edit;
end;

{ End TPColorComponentEditor }

{ TPColorEditor }

procedure TPColorEditor.FormCreate(Sender: TObject);
begin
  PColorOld := TPColor.Create(Self);
  with PColorOld do
  begin
    PColorOld.Parent := Self;
    Height := 0;
    Width := 0;
    Visible := False;
  end;
end;

procedure TPColorEditor.FormDestroy(Sender: TObject);
begin
  PColorOld.Free;
end;

procedure TPColorEditor.SetPColor(Value: TPColor);
begin
  FPColor := Value;
  PColorOld.Assign(FPColor);
  edtTitle.Text := Value.Title.Text;
  cbTitleVisible.Checked := Value.Title.Visible;
  edtNumbCol.Text := IntToStr(Value.NumbCol);
  edtContourLines.Text := IntToStr(Value.ContourLines);
  cbDrawFacet.Checked := Value.DrawFacet;
  cbMouseOn.Checked := Value.MouseOn;
  cbDrawColorBar.Checked := Value.DrawColorBar;
  if (Value.ColorBarKind = sbVertical) then rgColorBarKind.ItemIndex := 0
  else rgColorBarKind.ItemIndex := 1;
  case Value.ImageMode of
   imNormal   : cobImageMode.ItemIndex := 0;
   imGradient : cobImageMode.ItemIndex := 1;
  end;
  case Value.ColorMap of
   cmLine   : cobColorMap.ItemIndex := 0;
   cmRandom : cobColorMap.ItemIndex := 1;
   cmSpectr : cobColorMap.ItemIndex := 2;
   cmUser   : cobColorMap.ItemIndex := 3;
  end;
  case Value.TypeImage of
   dtContour       : cobTypeImage.ItemIndex := 0;
   dtFlat          : cobTypeImage.ItemIndex := 1;
   dtInterp        : cobTypeImage.ItemIndex := 2;
   dtInterpContour : cobTypeImage.ItemIndex := 3;
  end;
  cbMaxMinValGraphAuto.Checked := Value.MaxMinValGraphAuto;
  edtMaxValGraph.Text := Format('%1.5g', [Value.MaxValGraph]);
  edtMinValGraph.Text := Format('%1.5g', [Value.MinValGraph]);
  pnlValGraph.Enabled := not cbMaxMinValGraphAuto.Checked;
  cbGMaxMinValGraphAuto.Checked := Value.GMaxMinValGraphAuto;
  edtGMaxValGraph.Text := Format('%1.5g', [Value.GMaxValGraph]);
  edtGMinValGraph.Text := Format('%1.5g', [Value.GMinValGraph]);
  pnlGValGraph.Enabled := not cbGMaxMinValGraphAuto.Checked;
  cbCoordinatesAutomatic.Checked := Value.Coordinates.Automatic;
  edtImageTop.Text := IntToStr(Value.Coordinates.ImageTop);
  edtImageLeft.Text := IntToStr(Value.Coordinates.ImageLeft);
  edtImageHeight.Text := IntToStr(Value.Coordinates.ImageHeight);
  edtImageWidth.Text := IntToStr(Value.Coordinates.ImageWidth);
  edtColorBarTop.Text := IntToStr(Value.Coordinates.ColorBarTop);
  edtColorBarLeft.Text := IntToStr(Value.Coordinates.ColorBarLeft);
  edtColorBarHeight.Text := IntToStr(Value.Coordinates.ColorBarHeight);
  edtColorBarWidth.Text := IntToStr(Value.Coordinates.ColorBarWidth);
  edtTitleTop.Text := IntToStr(Value.Coordinates.TitleTop);
  edtTitleLeft.Text := IntToStr(Value.Coordinates.TitleLeft);
  edtTitleWidth.Text := IntToStr(Value.Coordinates.TitleWidth);
  gbImage.Enabled := not cbCoordinatesAutomatic.Checked;
  gbColorBar.Enabled := not cbCoordinatesAutomatic.Checked;
  gbTitle.Enabled := not cbCoordinatesAutomatic.Checked;
end;

procedure TPColorEditor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if Self.ModalResult <> mrOk then
  with FPColor do
  begin
    Title.Assign(PColorOld.Title);
    if NumbCol <> PColorOld.NumbCol then
      NumbCol := PColorOld.NumbCol;
    if ContourLines <> PColorOld.ContourLines then
      ContourLines := PColorOld.ContourLines;
    if DrawFacet <> PColorOld.DrawFacet then
      DrawFacet := PColorOld.DrawFacet;
    if MouseOn <> PColorOld.MouseOn then
      MouseOn := PColorOld.MouseOn;
    if DrawColorBar <> PColorOld.DrawColorBar then
      DrawColorBar := PColorOld.DrawColorBar;
    if ColorBarKind <> PColorOld.ColorBarKind then
      ColorBarKind := PColorOld.ColorBarKind;
    if ColorFon <> PColorOld.ColorFon then
      ColorFon := PColorOld.ColorFon;
    if ColorImageFon <> PColorOld.ColorImageFon then
      ColorImageFon := PColorOld.ColorImageFon;
    if ColorFacet <> PColorOld.ColorFacet then
      ColorFacet := PColorOld.ColorFacet;
    if ColorMaxValue <> PColorOld.ColorMaxValue then
      ColorMaxValue := PColorOld.ColorMaxValue;
    if ColorMinValue <> PColorOld.ColorMinValue then
      ColorMinValue := PColorOld.ColorMinValue;
    if ColorContour <> PColorOld.ColorContour then
      ColorContour := PColorOld.ColorContour;
    if ColorLower <> PColorOld.ColorLower then
      ColorLower := PColorOld.ColorLower;
    if ColorHigher <> PColorOld.ColorHigher then
      ColorHigher := PColorOld.ColorHigher;
    if ImageMode <> PColorOld.ImageMode then
      ImageMode := PColorOld.ImageMode;
    if ColorMap <> PColorOld.ColorMap then
      ColorMap := PColorOld.ColorMap;
    if TypeImage <> PColorOld.TypeImage then
      TypeImage := PColorOld.TypeImage;
    if MaxMinValGraphAuto <> PColorOld.MaxMinValGraphAuto then
      MaxMinValGraphAuto := PColorOld.MaxMinValGraphAuto;
    if not MaxMinValGraphAuto then
    begin
      MaxValGraph := PColorOld.MaxValGraph;
      MinValGraph := PColorOld.MinValGraph;
    end;
    if GMaxMinValGraphAuto <> PColorOld.GMaxMinValGraphAuto then
      GMaxMinValGraphAuto := PColorOld.GMaxMinValGraphAuto;
    if not GMaxMinValGraphAuto then
    begin
      GMaxValGraph := PColorOld.GMaxValGraph;
      GMinValGraph := PColorOld.GMinValGraph;
    end;
    Coordinates.Assign(PColorOld.Coordinates);
  end;
end;

procedure TPColorEditor.cbTitleVisibleClick(Sender: TObject);
begin
  FPColor.Title.Visible := cbTitleVisible.Checked ;
end;

procedure TPColorEditor.edtTitleChange(Sender: TObject);
begin
  FPColor.Title.Text := edtTitle.Text;
end;

procedure TPColorEditor.btnTitleFontClick(Sender: TObject);
begin
   FontDialog1.Font.Assign(FPColor.Title.Font);
   if FontDialog1.Execute then
   begin
     FPColor.Title.Font := FontDialog1.Font;
   end;
end;

procedure TPColorEditor.edtNumbColChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtNumbCol.Text, si, E);
  if E = 0 then FPColor.NumbCol := si;
end;

procedure TPColorEditor.edtContourLinesChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtContourLines.Text, si, E);
  if E = 0 then FPColor.ContourLines := si;
end;

procedure TPColorEditor.cbDrawFacetClick(Sender: TObject);
begin
  FPColor.DrawFacet := cbDrawFacet.Checked;
end;

procedure TPColorEditor.cbMouseOnClick(Sender: TObject);
begin
  FPColor.MouseOn := cbMouseOn.Checked;
end;

procedure TPColorEditor.cbDrawColorBarClick(Sender: TObject);
begin
  FPColor.DrawColorBar := cbDrawColorBar.Checked;
end;

procedure TPColorEditor.rgColorBarKindClick(Sender: TObject);
begin
  if rgColorBarKind.ItemIndex = 0 then FPColor.ColorBarKind := sbVertical
  else FPColor.ColorBarKind := sbHorizontal;
end;

procedure TPColorEditor.btnColorFonClick(Sender: TObject);
begin
  ColorDialog1.Color := FPColor.ColorFon;
  if ColorDialog1.Execute then
  begin
    FPColor.ColorFon := ColorDialog1.Color;
  end;
end;

procedure TPColorEditor.btnColorImageFonClick(Sender: TObject);
begin
  ColorDialog1.Color := FPColor.ColorImageFon;
  if ColorDialog1.Execute then
  begin
    FPColor.ColorImageFon := ColorDialog1.Color;
  end;
end;

procedure TPColorEditor.btnColorFacetClick(Sender: TObject);
begin
  ColorDialog1.Color := FPColor.ColorFacet;
  if ColorDialog1.Execute then
  begin
    FPColor.ColorFacet := ColorDialog1.Color;
  end;
end;

procedure TPColorEditor.btnColorContourClick(Sender: TObject);
begin
  ColorDialog1.Color := FPColor.ColorContour;
  if ColorDialog1.Execute then
  begin
    FPColor.ColorContour := ColorDialog1.Color;
  end;
end;

procedure TPColorEditor.btnColorMaxClick(Sender: TObject);
begin
  ColorDialog1.Color := FPColor.ColorMaxValue;
  if ColorDialog1.Execute then
  begin
    FPColor.ColorMaxValue := ColorDialog1.Color;
  end;
end;

procedure TPColorEditor.btnColorMinClick(Sender: TObject);
begin
  ColorDialog1.Color := FPColor.ColorMinValue;
  if ColorDialog1.Execute then
  begin
    FPColor.ColorMinValue := ColorDialog1.Color;
  end;
end;

procedure TPColorEditor.btnLowerClick(Sender: TObject);
begin
  ColorDialog1.Color := FPColor.ColorLower;
  if ColorDialog1.Execute then
  begin
    FPColor.ColorLower := ColorDialog1.Color;
  end;
end;

procedure TPColorEditor.btnHigherClick(Sender: TObject);
begin
  ColorDialog1.Color := FPColor.ColorHigher;
  if ColorDialog1.Execute then
  begin
    FPColor.ColorHigher := ColorDialog1.Color;
  end;
end;

procedure TPColorEditor.cobColorMapChange(Sender: TObject);
begin
  if cobColorMap.Text = 'cmLine' then FPColor.ColorMap := cmLine
  else if cobColorMap.Text = 'cmRandom' then FPColor.ColorMap := cmRandom
  else if cobColorMap.Text = 'cmSpectr' then FPColor.ColorMap := cmSpectr
  else if cobColorMap.Text = 'cmUser' then FPColor.ColorMap := cmUser;
end;

procedure TPColorEditor.cobTypeImageChange(Sender: TObject);
begin
  if cobTypeImage.Text = 'dtFlat' then FPColor.TypeImage := dtFlat
  else if cobTypeImage.Text = 'dtInterp' then FPColor.TypeImage := dtInterp
  else if cobTypeImage.Text = 'dtContour' then FPColor.TypeImage := dtContour
  else if cobTypeImage.Text = 'dtInterpContour' then
   FPColor.TypeImage := dtInterpContour;
end;

procedure TPColorEditor.cbCoordinatesAutomaticClick(Sender: TObject);
begin
  FPColor.Coordinates.Automatic := cbCoordinatesAutomatic.Checked;
  gbImage.Enabled := not cbCoordinatesAutomatic.Checked;
  gbColorBar.Enabled := not cbCoordinatesAutomatic.Checked;
  gbTitle.Enabled := not cbCoordinatesAutomatic.Checked;
  edtImageTop.Text := IntToStr(FPColor.Coordinates.ImageTop);
  edtImageLeft.Text := IntToStr(FPColor.Coordinates.ImageLeft);
  edtImageHeight.Text := IntToStr(FPColor.Coordinates.ImageHeight);
  edtImageWidth.Text := IntToStr(FPColor.Coordinates.ImageWidth);
  edtColorBarTop.Text := IntToStr(FPColor.Coordinates.ColorBarTop);
  edtColorBarLeft.Text := IntToStr(FPColor.Coordinates.ColorBarLeft);
  edtColorBarHeight.Text := IntToStr(FPColor.Coordinates.ColorBarHeight);
  edtColorBarWidth.Text := IntToStr(FPColor.Coordinates.ColorBarWidth);
  edtTitleTop.Text := IntToStr(FPColor.Coordinates.TitleTop);
  edtTitleLeft.Text := IntToStr(FPColor.Coordinates.TitleLeft);
  edtTitleWidth.Text := IntToStr(FPColor.Coordinates.TitleWidth);
end;

procedure TPColorEditor.edtImageTopChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtImageTop.Text, si, E);
  if E = 0 then FPColor.Coordinates.ImageTop := si;
end;

procedure TPColorEditor.edtImageLeftChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtImageLeft.Text, si, E);
  if E = 0 then FPColor.Coordinates.ImageLeft := si;
end;

procedure TPColorEditor.edtImageWidthChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtImageWidth.Text, si, E);
  if E = 0 then
  begin
    FPColor.Coordinates.ImageWidth := si;
    if si <> FPColor.Coordinates.ImageWidth then
      edtImageWidth.Text := IntToStr(FPColor.Coordinates.ImageWidth);
  end;
end;

procedure TPColorEditor.edtImageHeightChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtImageHeight.Text, si, E);
  if E = 0 then
  begin
    FPColor.Coordinates.ImageHeight := si;
    if si <> FPColor.Coordinates.ImageHeight then
      edtImageHeight.Text := IntToStr(FPColor.Coordinates.ImageHeight);
  end;
end;

procedure TPColorEditor.edtColorBarTopChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtColorBarTop.Text, si, E);
  if E = 0 then FPColor.Coordinates.ColorBarTop := si;
end;

procedure TPColorEditor.edtColorBarLeftChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtColorBarLeft.Text, si, E);
  if E = 0 then FPColor.Coordinates.ColorBarLeft := si;
end;

procedure TPColorEditor.edtColorBarWidthChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtColorBarWidth.Text, si, E);
  if E = 0 then FPColor.Coordinates.ColorBarWidth := si;
end;

procedure TPColorEditor.edtColorBarHeightChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtColorBarHeight.Text, si, E);
  if E = 0 then FPColor.Coordinates.ColorBarHeight := si;
end;

procedure TPColorEditor.edtTitleTopChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtTitleTop.Text, si, E);
  if E = 0 then FPColor.Coordinates.TitleTop := si;
end;

procedure TPColorEditor.edtTitleLeftChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtTitleLeft.Text, si, E);
  if E = 0 then FPColor.Coordinates.TitleLeft := si;
end;

procedure TPColorEditor.edtTitleWidthChange(Sender: TObject);
var
  E, si: Integer;
begin
  Val(edtTitleWidth.Text, si, E);
  if E = 0 then FPColor.Coordinates.TitleWidth := si;
end;

procedure TPColorEditor.cbMaxMinValGraphAutoClick(Sender: TObject);
begin
  FPColor.MaxMinValGraphAuto := cbMaxMinValGraphAuto.Checked;
  pnlValGraph.Enabled := not cbMaxMinValGraphAuto.Checked;
  if FPColor.MaxMinValGraphAuto then
  begin
    edtMaxValGraph.Text := Format('%1.5g', [FPColor.MaxValGraph]);
    edtMinValGraph.Text := Format('%1.5g', [FPColor.MinValGraph]);
  end;
end;

procedure TPColorEditor.edtMaxValGraphChange(Sender: TObject);
var
  S : String;
  si, temp : Extended;
begin
  S := edtMaxValGraph.Text;
  if TextToFloat(PChar(S), si, fvExtended) then
  begin
    temp := FPColor.MinValGraph;
    FPColor.MaxValGraph := si;
    if temp <> FPColor.MinValGraph then
      edtMinValGraph.Text := Format('%1.5g', [FPColor.MinValGraph]);
  end;
end;

procedure TPColorEditor.edtMinValGraphChange(Sender: TObject);
var
  S : String;
  si, temp : Extended;
begin
  S := edtMinValGraph.Text;
  if TextToFloat(PChar(S), si, fvExtended) then
  begin
    temp := FPColor.MaxValGraph;
    FPColor.MinValGraph := si;
    if temp <> FPColor.MaxValGraph then
      edtMaxValGraph.Text := Format('%1.5g', [FPColor.MaxValGraph]);
  end;
end;

procedure TPColorEditor.cbGMaxMinValGraphAutoClick(Sender: TObject);
begin
  FPColor.GMaxMinValGraphAuto := cbGMaxMinValGraphAuto.Checked;
  pnlGValGraph.Enabled := not cbGMaxMinValGraphAuto.Checked;
  if FPColor.GMaxMinValGraphAuto then
  begin
    edtGMaxValGraph.Text := Format('%1.5g', [FPColor.GMaxValGraph]);
    edtGMinValGraph.Text := Format('%1.5g', [FPColor.GMinValGraph]);
  end;
end;

procedure TPColorEditor.edtGMaxValGraphChange(Sender: TObject);
var
  S : String;
  si, temp : Extended;
begin
  S := edtGMaxValGraph.Text;
  if TextToFloat(PChar(S), si, fvExtended) then
  begin
    temp := FPColor.GMinValGraph;
    FPColor.GMaxValGraph := si;
    if temp <> FPColor.GMinValGraph then
      edtGMinValGraph.Text := Format('%1.5g', [FPColor.GMinValGraph]);
  end;
end;

procedure TPColorEditor.edtGMinValGraphChange(Sender: TObject);
var
  S : String;
  si, temp : Extended;
begin
  S := edtGMinValGraph.Text;
  if TextToFloat(PChar(S), si, fvExtended) then
  begin
    temp := FPColor.GMaxValGraph;
    FPColor.GMinValGraph := si;
    if temp <> FPColor.GMaxValGraph then
      edtGMaxValGraph.Text := Format('%1.5g', [FPColor.GMaxValGraph]);
  end;
end;

procedure TPColorEditor.cobImageModeChange(Sender: TObject);
begin
  if cobImageMode.Text = 'imNormal' then FPColor.ImageMode := imNormal
  else if cobImageMode.Text = 'imGradient' then FPColor.ImageMode := imGradient;
end;

procedure TPColorEditor.edtXKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in NumbKeys) then Key := Char(0);
end;

{ End TPColorEditor }

end.
